dimension=6000
types_count=34
deg_count=394
nonnegative_ineq = vector(QQ,dimension)

print("The number of {C3,C4,C6}-free graphs on 6 vertices = %d" % dimension)

print("loading the Sum-of-Squares representation of the PSD matrices...")
f=open("./types_list")
for type_id in range(types_count):
	type_name = f.readline()[:-1]
	(M,min_w) = load_SoS_matrix("./M_%d"%type_id)
	print("  Matrix %d for type '%s' loaded; minimum weight in Sum-of-Squares representation: %s" %(type_id, type_name, min_w))
	
	print("  Loading '[[ A^sigma x B^sigma ]]_sigma' coefficients for Cauchy-Schwarz calculus")
	table = load_CS_table('cs_%d' % type_id)

	for graph_id in range(dimension):
		pair_density = Matrix(field, M.nrows(), M.ncols())
		for (x,y) in table[graph_id].keys():
			pair_density[x,y]=table[graph_id][x,y]
			pair_density[y,x]=table[graph_id][x,y]
		nonnegative_ineq[graph_id] += dot_matrix(pair_density, M)
	print("")
#for type_id
f.close()

print("loading %d inequalities of the form 'w*[[ (100000*out_degree - 20009) × Fj ]] = 0'..." % deg_count)
f=open("./w_deg")
for deg_id in range(deg_count):
	weight = field(f.readline()[:-1])
	deg_vector = load_vector("./deg_%d" % deg_id)
	nonnegative_ineq += weight * deg_vector
#for deg_id
f.close()

max_coord = max(nonnegative_ineq)
print("All the coordinates are upper-bounded by %s ~ %.10lf \t this being strictly negative yields there are no oriented graphons with every out_degree == 0.20009" % (max_coord, float(max_coord)))
