from os import chdir
import sys, re

field = QQ

def dot_matrix(A,B):
	val=0
	for i in range(A.nrows()):
		for j in range(A.ncols()):
			val+=A[i,j]*B[i,j]
	return val
#END: dot_matrix

def load_value(filename):
	f=open(filename)
	fline=f.readline()[:-1]
	f.close()
	return field(fline)
#END: load_value

def load_vector(filename):
	f=open(filename)
	fline=f.readline()[:-1]
	f.close()
	return vector(field, fline.split(','))
#END: load_vector

def load_SoS_matrix(filename):
	f=open(filename)
	min_eig=sys.maxsize

	vec=[]; eig=[]; count = 0
	while True: 
		fline=f.readline()[:-1]
		if (fline==''): break
		count+=1
		eig.append(field(fline))
		if (eig[-1]<min_eig): min_eig=eig[-1]
		fline=f.readline()[:-1]
		vec.append( [field(_) for _ in fline.split(',')] )
	f.close()
	dimension = len(vec[0]) if (count>0) else 0
	m = matrix(field,dimension)
	for i in range(count):
		for row in range(dimension):
			for col in range(dimension):
				m[row,col] += eig[i] * vec[i][row] * vec[i][col]
	return (m,min_eig)
#END: load_matrix

#load pairing densities for a given flag-type
def load_CS_table(filename):
	f=open(filename)

	table=[]
	while True: 
		fline=f.readline()[:-1]
		if (fline==''): break
		size=int(fline)
		item={}
		for j in range(size):
			fline=f.readline()[:-1]
			(A,B,value)=map(int,fline.split())
			item[(A,B)]=value
		table.append(item)
	f.close()

	return table
#END: load_CS_table

print("Proof of Lemma 2.4:")
chdir("lemma24_files")
load("verify.sage")
chdir("..")

print("\n\n\n")

print("Proof of Lemma 2.5:")
chdir("lemma25_files")
load("verify.sage")
chdir("..")
